# @file               OpenDrone - Python to Control FC-01
# @technical support  Ethan Huang <ethan@robotlab.tw>
# @version            V1.0.1
# @date               2018/05/12

import socket
import time
import random

def joystick_value_map(val, from_min, from_max, to_min, to_max):
    return (val - from_min) * (to_max - to_min) / (from_max - from_min) + to_min

def opendrone_checksum_calculate(ssid,roll,pitch,yaw,throttle):
    _ssid = ssid[-2:]
    _ssid_a = _ssid[0]
    _ssid_b = _ssid[1]

    _ssid_a = ord(_ssid_a) << 8
    _ssid_b = ord(_ssid_b)

    ssid_code = _ssid_a | _ssid_b
    
    checksum = (roll + pitch + yaw + throttle + ssid_code) & 0x00ff
    return hex(checksum)[-2:]


ip = "192.168.4.1"
port = 6666

sock = socket.socket(socket.AF_INET,socket.SOCK_DGRAM)
sock.setblocking(0)

start_indicator = "@$"
ssid            = "OD1111"
other_value     = "00"
checksum        = 0x00
    
while True:

    '''
    roll_value      = 2047
    pitch_value     = 4095
    yaw_value       = joystick_value_map(2047, 0, 4095, 4095, 0)
    throttle_value  = joystick_value_map(192, 0, 4095, 4095, 0)
    '''
    roll_value      = int(random.uniform(0,4095))
    pitch_value     = int(random.uniform(0,4095))
    yaw_value       = joystick_value_map( int(random.uniform(0,4095)) , 0, 4095, 4095, 0)
    throttle_value  = joystick_value_map( int(random.uniform(0,4095)) , 0, 4095, 4095, 0)

    arming_value    = "00"
    
    opendrone_protocol = start_indicator
    opendrone_protocol += "|"
    opendrone_protocol += str(roll_value)
    opendrone_protocol += "|"
    opendrone_protocol += str(pitch_value)
    opendrone_protocol += "|"
    opendrone_protocol += str(throttle_value)
    opendrone_protocol += "|"
    opendrone_protocol += str(yaw_value)
    opendrone_protocol += "|"
    opendrone_protocol += str(arming_value)
    opendrone_protocol += "|"
    opendrone_protocol += other_value
    opendrone_protocol += "|"
    opendrone_protocol += other_value
    opendrone_protocol += "|"
    opendrone_protocol += ssid
    opendrone_protocol += "|"
    opendrone_protocol += opendrone_checksum_calculate(ssid, roll_value, pitch_value, yaw_value, throttle_value)

    print opendrone_protocol
    sock.sendto(opendrone_protocol, (ip, port))
    #time.sleep(0.02)
    time.sleep(0.02)
        
        
sock.close()
